define(["focusManager","dom","subtitleAppearanceHelper","loading","apphost","globalize","userSettingsBuilder","connectionManager","userSettings","emby-scroller","listViewStyle","emby-select","emby-input","emby-checkbox","flexStyles"],function(focusManager,dom,subtitleAppearanceHelper,loading,appHost,globalize,userSettingsBuilder,connectionManager,currentUserSettings){"use strict";function numberToPercentString(value){try{return new Intl.NumberFormat(globalize.getCurrentLocales(),{style:"percent"}).format(value/100)}catch(err){return console.log("Error in NumberFormat: "+err),value+"%"}}function getSubtitleAppearanceObject(context){var appearanceSettings={};return appearanceSettings.verticalPosition=context.querySelector(".selectVerticalPosition").value,appearanceSettings.textSize=context.querySelector(".selectTextSize").value,appearanceSettings.dropShadow=context.querySelector(".selectDropShadow").value,appearanceSettings.textBackground=context.querySelector(".inputTextBackground").value,appearanceSettings.textColor=context.querySelector(".inputTextColor").value,appearanceSettings}function loadForm(context,user,userSettings,appearanceSettings,apiClient){apiClient.getCultures().then(function(allCultures){!function(select,languages,value){var html="";html+="<option"+(value?"":" selected")+" value=''>"+globalize.translate("AnyLanguage")+"</option>";for(var i=0,length=languages.length;i<length;i++){var culture=languages[i];html+="<option"+(value===culture.TwoLetterISOLanguageName||value===culture.ThreeLetterISOLanguageName?" selected":"")+" value='"+culture.TwoLetterISOLanguageName+"'>"+culture.DisplayName+"</option>"}select.innerHTML=html}(context.querySelector(".selectSubtitleLanguage"),allCultures,user.Configuration.SubtitleLanguagePreference);var select,options,selectVerticalPosition=context.querySelector(".selectVerticalPosition");select=selectVerticalPosition,(options=[{name:numberToPercentString(90),value:90},{name:numberToPercentString(80),value:80},{name:numberToPercentString(70),value:70},{name:numberToPercentString(60),value:60},{name:numberToPercentString(50),value:50},{name:numberToPercentString(40),value:40},{name:numberToPercentString(30),value:30},{name:numberToPercentString(20),value:20},{name:numberToPercentString(10),value:10},{name:globalize.translate("Bottom"),value:0}]).reverse(),select.innerHTML=options.map(function(o){return'<option value="'+o.value+'">'+o.name+"</option>"}).join(""),selectVerticalPosition.value=appearanceSettings.verticalPosition||"10",context.querySelector(".selectSubtitlePlaybackMode").value=user.Configuration.SubtitleMode||"",context.querySelector(".selectSubtitlePlaybackMode").dispatchEvent(new CustomEvent("change",{})),context.querySelector(".selectTextSize").value=appearanceSettings.textSize||"",context.querySelector(".selectDropShadow").value=appearanceSettings.dropShadow||"",context.querySelector(".inputTextBackground").value=appearanceSettings.textBackground||"transparent",context.querySelector(".inputTextColor").value=appearanceSettings.textColor||"#ffffff",context.querySelector(".chkRememberSubtitles").checked=user.Configuration.RememberSubtitleSelections||!1,onAppearanceFieldChange({target:context.querySelector(".selectTextSize")}),onAppearanceFieldChange({target:context.querySelector(".selectVerticalPosition")}),loading.hide()})}function save(context,userId,userSettings,apiClient,enableSaveConfirmation){loading.show(),apiClient.getUser(userId).then(function(user){(function(context,user,userSettingsInstance,appearanceKey,apiClient){var appearanceSettings=userSettingsInstance.getSubtitleAppearanceSettings(appearanceKey),appearanceSettings=Object.assign(appearanceSettings,getSubtitleAppearanceObject(context));return userSettingsInstance.setSubtitleAppearanceSettings(appearanceSettings,appearanceKey),user.Configuration.SubtitleLanguagePreference=context.querySelector(".selectSubtitleLanguage").value,user.Configuration.SubtitleMode=context.querySelector(".selectSubtitlePlaybackMode").value,user.Configuration.RememberSubtitleSelections=context.querySelector(".chkRememberSubtitles").checked,apiClient.updateUserConfiguration(user.Id,user.Configuration)})(context,user,userSettings,null,apiClient).then(function(){var options;loading.hide(),enableSaveConfirmation&&(options=globalize.translate("SettingsSaved"),require(["toast"],function(toast){toast(options)}))},function(){loading.hide()})})}function onSubmit(e){var options=this,apiClient=connectionManager.getApiClient(options.serverId),userId=options.userId,userSettings=options.userSettings;return userSettings.setUserInfo(userId,apiClient).then(function(){var enableSaveConfirmation=options.enableSaveConfirmation;save(options.element,userId,userSettings,apiClient,enableSaveConfirmation)}),e&&e.preventDefault(),!1}function onSubtitleModeChange(e){for(var view=e.target.closest(".subtitlesettings"),subtitlesHelp=view.querySelectorAll(".subtitlesHelp"),i=0,length=subtitlesHelp.length;i<length;i++)subtitlesHelp[i].classList.add("hide");view.querySelector(".subtitles"+this.value+"Help").classList.remove("hide")}function onAppearanceFieldChange(e){var view=e.target.closest(".subtitlesettings"),appearanceSettings=getSubtitleAppearanceObject(view),elements={window:view.querySelector(".subtitleappearance-preview-window"),text:view.querySelector(".subtitleappearance-preview-text")};subtitleAppearanceHelper.applyStyles(elements,appearanceSettings)}function onTrackSelectionsCleared(){loading.hide()}return function(view,params){var apiClient=connectionManager.getApiClient(params.serverId),userId=params.userId||apiClient.getCurrentUserId(),userSettings=userId===apiClient.getCurrentUserId()?currentUserSettings:new userSettingsBuilder,options={serverId:apiClient.serverId(),userId:userId,element:view.querySelector(".settingsContainer"),userSettings:userSettings,enableSaveButton:!1,enableSaveConfirmation:!1};options.element.classList.add("subtitlesettings"),apiClient.isMinServerVersion("4.6.0.16")?options.element.querySelector(".fldClearTrackSelections").classList.remove("hide"):options.element.querySelector(".fldClearTrackSelections").classList.add("hide"),options.element.querySelector("form").addEventListener("submit",onSubmit.bind(options)),options.element.querySelector(".btnClearTrackSelections").addEventListener("click",function(e){var options=this,mode=e.target.closest("button").getAttribute("data-mode");require(["confirm"]).then(function(responses){return responses[0]({title:globalize.translate("HeaderClearTrackSelections"),text:globalize.translate("QuestionClearSavedTracks"),confirmText:globalize.translate("HeaderClearTrackSelections"),primary:"cancel"}).then(function(){return loading.show(),connectionManager.getApiClient(options.serverId).clearUserTrackSelections(options.userId,mode).then(onTrackSelectionsCleared,onTrackSelectionsCleared)})})}.bind(options)),options.element.querySelector(".selectSubtitlePlaybackMode").addEventListener("change",onSubtitleModeChange),options.element.querySelector(".selectTextSize").addEventListener("change",onAppearanceFieldChange),options.element.querySelector(".selectVerticalPosition").addEventListener("change",onAppearanceFieldChange),options.element.querySelector(".selectDropShadow").addEventListener("change",onAppearanceFieldChange),options.element.querySelector(".inputTextColor").addEventListener("change",onAppearanceFieldChange),options.element.querySelector(".inputTextBackground").addEventListener("change",onAppearanceFieldChange),options.enableSaveButton&&options.element.querySelector(".btnSave").classList.remove("hide"),appHost.supports("subtitleappearancesettings")&&options.element.querySelector(".subtitleAppearanceSection").classList.remove("hide"),view.addEventListener("viewshow",function(e){e.detail.isRestored||function(options){var context=options.element;loading.show();var userId=options.userId,apiClient=connectionManager.getApiClient(options.serverId),userSettings=options.userSettings;apiClient.getUser(userId).then(function(user){(userId===apiClient.getCurrentUserId()?Promise.resolve():userSettings.setUserInfo(userId,apiClient)).then(function(){var appearanceSettings=userSettings.getSubtitleAppearanceSettings(options.appearanceKey);loadForm(context,user,0,appearanceSettings,apiClient),focusManager.autoFocus(context)})})}(options)}),view.addEventListener("viewbeforehide",function(){onSubmit.call(options)}),view.addEventListener("viewdestroy",function(){options=null})}});